import * as vue from 'vue';
import { ComputedRef, PropType } from 'vue';
import { UseCheckboxGroupProps } from './checkbox.types.js';
import { ThemingProps } from '@chakra-ui/styled-system';

interface CCheckboxGroupProps extends UseCheckboxGroupProps, Omit<ThemingProps<"Checkbox">, "orientation"> {
}
type CheckboxGroupContext = ComputedRef<ThemingProps & {
    isDisabled?: boolean;
    value: (string | number)[];
    handleChange(value: number | string, isChecked: boolean): void;
}>;
declare const useCheckboxGroupContext: (fallback?: CheckboxGroupContext | undefined) => CheckboxGroupContext;
declare const CCheckboxGroup: vue.DefineComponent<{
    colorScheme: PropType<(string & {}) | "blue" | "cyan" | "gray" | "green" | "orange" | "pink" | "purple" | "red" | "teal" | "yellow" | "whiteAlpha" | "blackAlpha" | "linkedin" | "facebook" | "messenger" | "whatsapp" | "twitter" | "telegram" | undefined>;
    variant: PropType<any>;
    size: PropType<any>;
    styleConfig: PropType<Record<string, any> | undefined>;
    modelValue: {
        type: PropType<(string | number)[]>;
        default: () => never[];
    };
    isDisabled: {
        type: PropType<boolean>;
        default: boolean;
    };
}, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, ("change" | "update:modelValue")[], "change" | "update:modelValue", vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps, Readonly<vue.ExtractPropTypes<{
    colorScheme: PropType<(string & {}) | "blue" | "cyan" | "gray" | "green" | "orange" | "pink" | "purple" | "red" | "teal" | "yellow" | "whiteAlpha" | "blackAlpha" | "linkedin" | "facebook" | "messenger" | "whatsapp" | "twitter" | "telegram" | undefined>;
    variant: PropType<any>;
    size: PropType<any>;
    styleConfig: PropType<Record<string, any> | undefined>;
    modelValue: {
        type: PropType<(string | number)[]>;
        default: () => never[];
    };
    isDisabled: {
        type: PropType<boolean>;
        default: boolean;
    };
}>> & {
    onChange?: ((...args: any[]) => any) | undefined;
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
}, {
    modelValue: (string | number)[];
    isDisabled: boolean;
}>;

export { CCheckboxGroup, CCheckboxGroupProps, CheckboxGroupContext, useCheckboxGroupContext };
