"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/checkbox-group.tsx
var checkbox_group_exports = {};
__export(checkbox_group_exports, {
  CCheckboxGroup: () => CCheckboxGroup,
  useCheckboxGroupContext: () => useCheckboxGroupContext
});
module.exports = __toCommonJS(checkbox_group_exports);
var import_vue = require("vue");
var import_vue_utils = require("@chakra-ui/vue-utils");

// src/use-checkbox-group.ts
function useCheckboxGroup(props) {
  const {
    modelValue,
    isDisabled
  } = props;
  function handleChange(value, isChecked) {
    if (!value || !modelValue.value)
      return;
    modelValue.value = isChecked ? [.../* @__PURE__ */ new Set([...modelValue.value, value])] : modelValue.value.filter((v) => String(v) !== String(value));
  }
  __name(handleChange, "handleChange");
  return {
    modelValue,
    isDisabled,
    handleChange
  };
}
__name(useCheckboxGroup, "useCheckboxGroup");

// src/checkbox-group.tsx
var [CheckboxGroupProvider, useCheckboxGroupContext] = (0, import_vue_utils.createContext)({
  strict: false,
  name: "CheckboxGroupContext"
});
var CCheckboxGroup = (0, import_vue.defineComponent)({
  name: "CCheckboxGroup",
  props: {
    modelValue: {
      type: Object,
      // eslint-disable-next-line vue/require-valid-default-prop
      default: () => []
    },
    isDisabled: {
      type: Boolean,
      default: false
    },
    ...import_vue_utils.vueThemingProps
  },
  emits: ["change", "update:modelValue"],
  setup(props, {
    emit,
    slots
  }) {
    const checkBoxGroupValue = (0, import_vue.computed)({
      get() {
        return props.modelValue;
      },
      set(value) {
        emit("update:modelValue", value);
      }
    });
    const {
      modelValue,
      handleChange
    } = useCheckboxGroup({
      modelValue: checkBoxGroupValue,
      isDisabled: (0, import_vue.computed)(() => props.isDisabled)
    });
    const checkboxGroupContext = (0, import_vue.computed)(() => ({
      size: props.size,
      variant: props.variant,
      isDisabled: props.isDisabled,
      colorScheme: props.colorScheme,
      value: modelValue.value,
      handleChange
    }));
    CheckboxGroupProvider(checkboxGroupContext);
    return () => (0, import_vue.renderSlot)(slots, "default");
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CCheckboxGroup,
  useCheckboxGroupContext
});
