"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  CCheckbox: () => CCheckbox,
  CCheckboxGroup: () => CCheckboxGroup,
  useCheckboxGroupContext: () => useCheckboxGroupContext
});
module.exports = __toCommonJS(src_exports);

// src/checkbox.tsx
var import_vue4 = require("vue");
var import_vue5 = require("vue");
var import_vue_system2 = require("@chakra-ui/vue-system");
var import_styled_system = require("@chakra-ui/styled-system");
var import_vue_utils3 = require("@chakra-ui/vue-utils");
var checkbox = __toESM(require("@zag-js/checkbox"));
var import_vue6 = require("@zag-js/vue");
var import_vue_composables = require("@chakra-ui/vue-composables");
var import_utils = require("@chakra-ui/utils");
var import_c_form_control = require("@chakra-ui/c-form-control");

// src/checkbox-icon.tsx
var import_vue = require("vue");
var import_motion = require("@vueuse/motion");
var import_vue2 = require("vue");
var import_vue_system = require("@chakra-ui/vue-system");
var import_c_motion = require("@chakra-ui/c-motion");
var import_vue_utils = require("@chakra-ui/vue-utils");
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !(0, import_vue.isVNode)(s);
}
__name(_isSlot, "_isSlot");
var CheckIcon = (0, import_vue2.defineComponent)({
  name: "CheckboxCheckIcon",
  setup(_, {
    attrs,
    slots
  }) {
    const transitionId = `check-icon-${(0, import_vue_utils.genId)()}`;
    const leave = /* @__PURE__ */ __name((done) => {
      const motions = (0, import_motion.useMotions)();
      const instance = motions[transitionId];
      instance == null ? void 0 : instance.leave(() => {
        done();
      });
    }, "leave");
    (0, import_vue2.onBeforeUnmount)(() => {
      leave(() => null);
    });
    return () => (0, import_vue.createVNode)(import_vue_system.chakra.svg, (0, import_vue.mergeProps)({
      "width": "1.2em",
      "viewBox": "0 0 12 10",
      "style": {
        fill: "none",
        strokeWidth: 2,
        stroke: "currentColor",
        strokeDasharray: 16
      }
    }, attrs), {
      default: () => (0, import_vue.createVNode)("polyline", {
        "points": "1.5 6 4.5 9 10.5 1"
      }, null)
    });
  }
});
var IndeterminateIcon = (0, import_vue2.defineComponent)({
  name: "CheckboxIndeterminateIcon",
  setup(_, {
    attrs,
    slots
  }) {
    const transitionId = `indeterminate-icon-${(0, import_vue_utils.genId)()}`;
    const leave = /* @__PURE__ */ __name((done) => {
      const motions = (0, import_motion.useMotions)();
      const instance = motions[transitionId];
      instance == null ? void 0 : instance.leave(() => {
        done();
      });
    }, "leave");
    (0, import_vue2.onBeforeUnmount)(() => {
      leave(() => null);
    });
    return () => (0, import_vue.createVNode)(import_vue_system.chakra.svg, (0, import_vue.mergeProps)({
      "width": "1.2em",
      "viewBox": "0 0 24 24",
      "style": {
        stroke: "currentColor",
        strokeWidth: 4
      }
    }, attrs), {
      default: () => (0, import_vue.createVNode)("line", {
        "x1": "21",
        "x2": "3",
        "y1": "12",
        "y2": "12"
      }, null)
    });
  }
});
var CCheckboxTransition = (0, import_vue2.defineComponent)({
  name: "CCheckboxTransition",
  props: {
    open: Boolean
  },
  setup(props, {
    attrs,
    slots
  }) {
    return () => (0, import_vue.createVNode)(import_c_motion.CMotion, {
      "type": "scale",
      "style": {
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        height: "100%"
      }
    }, {
      default: () => [props.open ? () => (0, import_vue.createVNode)(import_vue_system.chakra.div, null, _isSlot(slots) ? slots : {
        default: () => [slots]
      }) : null]
    });
  }
});
var CheckboxIcon = (0, import_vue2.defineComponent)((props, {
  slots,
  attrs
}) => {
  const IconEl = (0, import_vue2.computed)(() => props.isIndeterminate ? IndeterminateIcon : CheckIcon);
  return () => (0, import_vue.createVNode)(IconEl.value, attrs, null);
});
CheckboxIcon.name = "CheckboxIcon";
CheckboxIcon.props = {
  isIndeterminate: Boolean,
  isChecked: Boolean
};

// src/checkbox-group.tsx
var import_vue3 = require("vue");
var import_vue_utils2 = require("@chakra-ui/vue-utils");

// src/use-checkbox-group.ts
function useCheckboxGroup(props) {
  const {
    modelValue,
    isDisabled
  } = props;
  function handleChange(value, isChecked) {
    if (!value || !modelValue.value)
      return;
    modelValue.value = isChecked ? [.../* @__PURE__ */ new Set([...modelValue.value, value])] : modelValue.value.filter((v) => String(v) !== String(value));
  }
  __name(handleChange, "handleChange");
  return {
    modelValue,
    isDisabled,
    handleChange
  };
}
__name(useCheckboxGroup, "useCheckboxGroup");

// src/checkbox-group.tsx
var [CheckboxGroupProvider, useCheckboxGroupContext] = (0, import_vue_utils2.createContext)({
  strict: false,
  name: "CheckboxGroupContext"
});
var CCheckboxGroup = (0, import_vue3.defineComponent)({
  name: "CCheckboxGroup",
  props: {
    modelValue: {
      type: Object,
      // eslint-disable-next-line vue/require-valid-default-prop
      default: () => []
    },
    isDisabled: {
      type: Boolean,
      default: false
    },
    ...import_vue_utils2.vueThemingProps
  },
  emits: ["change", "update:modelValue"],
  setup(props, {
    emit,
    slots
  }) {
    const checkBoxGroupValue = (0, import_vue3.computed)({
      get() {
        return props.modelValue;
      },
      set(value) {
        emit("update:modelValue", value);
      }
    });
    const {
      modelValue,
      handleChange
    } = useCheckboxGroup({
      modelValue: checkBoxGroupValue,
      isDisabled: (0, import_vue3.computed)(() => props.isDisabled)
    });
    const checkboxGroupContext = (0, import_vue3.computed)(() => ({
      size: props.size,
      variant: props.variant,
      isDisabled: props.isDisabled,
      colorScheme: props.colorScheme,
      value: modelValue.value,
      handleChange
    }));
    CheckboxGroupProvider(checkboxGroupContext);
    return () => (0, import_vue3.renderSlot)(slots, "default");
  }
});

// src/checkbox.tsx
function _isSlot2(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !(0, import_vue4.isVNode)(s);
}
__name(_isSlot2, "_isSlot");
var CCheckboxControl = (0, import_vue_system2.chakra)("span", {
  baseStyle: {
    display: "inline-flex",
    alignItems: "center",
    justifyContent: "center",
    verticalAlign: "top",
    userSelect: "none",
    flexShrink: 0
  }
});
var CLabel = (0, import_vue_system2.chakra)("label", {
  baseStyle: {
    cursor: "pointer",
    display: "inline-flex",
    alignItems: "center",
    verticalAlign: "top",
    position: "relative"
  }
});
var CCheckbox = (0, import_vue5.defineComponent)({
  name: "CCheckbox",
  props: {
    modelValue: {
      type: Boolean,
      default: false
    },
    value: [String, Number],
    id: String,
    isIndeterminate: Boolean,
    isFocusable: Boolean,
    isRequired: Boolean,
    isInvalid: Boolean,
    isDisabled: Boolean,
    isReadonly: Boolean,
    defaultChecked: Boolean,
    name: String,
    "aria-label": String,
    "aria-labelledby": String,
    "aria-invalid": Boolean,
    "aria-describedby": String,
    spacing: {
      type: import_vue_utils3.SNAO,
      default: "0.5rem"
    },
    iconColor: String,
    iconSize: [String, Number],
    icon: Object,
    inputProps: Object,
    ...import_vue_utils3.vueThemingProps
  },
  emits: ["change", "update:modelValue"],
  setup(props, {
    slots,
    attrs,
    emit
  }) {
    const group = useCheckboxGroupContext((0, import_vue5.computed)(() => ({})));
    const ownProps = (0, import_vue5.computed)(() => (0, import_styled_system.omitThemingProps)(props));
    const mergedProps = (0, import_vue5.computed)(() => (0, import_utils.mergeWith)({}, group.value, props, attrs));
    const styles = (0, import_vue_system2.useMultiStyleConfig)("Checkbox", mergedProps);
    const inheritedFormControlProps = (0, import_c_form_control.useFormControlContext)(mergedProps);
    const id = (0, import_vue_utils3.genId)();
    const [rootId, inputId, controlId, labelId] = (0, import_vue_composables.useIds)(`chakra-checkbox-${id}`, "root", "input", "control", "label");
    const machineContext = (0, import_vue5.computed)(() => {
      var _a, _b, _c, _d;
      const _inheritedFormControlProps = (0, import_utils.pick)((inheritedFormControlProps == null ? void 0 : inheritedFormControlProps.value) || {}, ["isRequired", "isDisabled", "isInvalid", "isReadOnly"]);
      const cleanedContextProps = (0, import_utils.filterUndefined)({
        readonly: (_a = _inheritedFormControlProps == null ? void 0 : _inheritedFormControlProps.isReadOnly) == null ? void 0 : _a.value,
        required: (_b = _inheritedFormControlProps == null ? void 0 : _inheritedFormControlProps.isRequired) == null ? void 0 : _b.value,
        disabled: (_c = _inheritedFormControlProps == null ? void 0 : _inheritedFormControlProps.isDisabled) == null ? void 0 : _c.value,
        invalid: (_d = _inheritedFormControlProps == null ? void 0 : _inheritedFormControlProps.isInvalid) == null ? void 0 : _d.value
      });
      const cleanedOwnProps = (0, import_utils.filterUndefined)({
        required: props.isRequired,
        disabled: props.isDisabled,
        invalid: props.isInvalid,
        readonly: props.isReadonly,
        focusable: props.isFocusable,
        "aria-invalid": props["aria-invalid"],
        "aria-label": props["aria-label"],
        "aria-labelledby": props["aria-labelledby"],
        "aria-describedby": props["aria-describedby"]
      });
      return (0, import_utils.mergeWith)({}, cleanedContextProps, cleanedOwnProps, {
        value: props.value,
        defaultChecked: props.defaultChecked,
        indeterminate: props.isIndeterminate
      });
    });
    const context = (0, import_vue5.computed)(() => ({
      id,
      ids: {
        root: rootId.value,
        input: inputId.value,
        control: controlId.value,
        labelId: labelId.value
      },
      ...machineContext.value
    }));
    const [state, send] = (0, import_vue6.useMachine)(
      // @ts-ignore
      checkbox.machine({
        ...context.value
      })
    );
    const api = (0, import_vue5.computed)(() => (
      // @ts-ignore
      checkbox.connect(state.value, send, import_vue6.normalizeProps)
    ));
    const iconStyles = (0, import_vue5.computed)(() => ({
      opacity: api.value.isChecked || api.value.isIndeterminate ? 1 : 0,
      transform: api.value.isChecked || api.value.isIndeterminate ? "scale(1)" : "scale(0.95)",
      fontSize: props.iconSize,
      color: props.iconColor,
      ...styles.value.icon
    }));
    const clonedIcon = (0, import_vue5.computed)(() => (0, import_vue5.cloneVNode)((0, import_vue5.h)(CheckboxIcon), {
      __css: iconStyles.value,
      isIndeterminate: api.value.isIndeterminate,
      isChecked: api.value.isChecked
    }));
    if (props.defaultChecked && api.value) {
      api.value.setChecked(true);
    }
    if (api.value) {
      if (group.value.value && ownProps.value.value) {
        const isChecked = group.value.value.includes(ownProps.value.value);
        api.value.setChecked(isChecked);
      }
    }
    (0, import_vue5.watch)(() => api.value.isChecked, (value) => {
      emit("update:modelValue", value);
      emit("change", value);
      if (group.value.handleChange && ownProps.value.value) {
        group.value.handleChange(ownProps.value.value, value);
      }
    });
    (0, import_vue5.watch)(() => props.isIndeterminate, (value) => {
      if (api.value && !api.value.isReadOnly) {
        api.value.setIndeterminate(value);
      }
    });
    (0, import_vue5.watch)(() => props.modelValue, (value) => {
      api.value.setChecked(value);
    });
    const inputProps = (0, import_vue5.computed)(() => (0, import_vue6.mergeProps)(api.value.inputProps, {
      onChange() {
        if (api.value.isIndeterminate && !api.value.isReadOnly) {
          api.value.setIndeterminate(false);
          api.value.setChecked(true);
        }
      }
    }));
    return () => {
      const children = (0, import_vue_utils3.getValidChildren)(slots);
      const hasChildren = children.length > 0;
      return (0, import_vue4.createVNode)(import_vue_system2.chakra.div, {
        "sx": {
          "> div": styles.value.container
        }
      }, {
        default: () => (0, import_vue4.createVNode)(CLabel, (0, import_vue4.mergeProps)({
          "__label": "checkbox"
        }, api.value.rootProps, {
          "__css": styles.value.container
        }), {
          default: () => (0, import_vue4.createVNode)(import_vue4.Fragment, null, [(0, import_vue4.createVNode)("input", (0, import_vue4.mergeProps)({
            "class": "chakra-checkbox__input"
          }, inputProps.value), null), (0, import_vue4.createVNode)(CCheckboxControl, (0, import_vue4.mergeProps)({
            "__label": "checkbox__control",
            "__css": styles.value.control
          }, api.value.controlProps), {
            default: () => clonedIcon.value
          }), hasChildren && (0, import_vue4.createVNode)(import_vue_system2.chakra.span, (0, import_vue4.mergeProps)({
            "label": "checkbox__label"
          }, api.value.labelProps, {
            "__css": {
              marginStart: props.spacing,
              ...styles.value.label
            }
          }), _isSlot2(slots) ? slots : {
            default: () => [slots]
          })])
        })
      });
    };
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CCheckbox,
  CCheckboxGroup,
  useCheckboxGroupContext
});
